VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows-Standard
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

'//////////////////////////
'
' Author:           Sascha Wittling
' Zweck der bung:  Ermitteln der Eigenschaften eingebauter VB-
'                   Steuerelemente zur Laufzeit
' Bei Fragen:       baum@ich-will-net.de
' Sonst was:        Steuerelemente braucht man keine auf Form1 zu
'                   pinseln, das macht wie man sehen kann Form_Load()
'                   schon selber ;)
'
'\\\\\\\\\\\\\\\\\\\\\\\\\\

'Listbox fr Steuerelemente
Private WithEvents lstControls As VB.ListBox
Attribute lstControls.VB_VarHelpID = -1

'Listbox fr Eigenschaften der Steuerelemente
Private WithEvents lstMembers As VB.ListBox
Attribute lstMembers.VB_VarHelpID = -1

'Textbox fr den Wert einer Eigenschaft
Private txtValue As VB.TextBox

Private Sub Form_Load()
    Dim ctlControl As Control
    
    'Steuerelemente generieren und platzieren
    Set lstControls = Me.Controls.Add("VB.ListBox", "lstControls")
    Set lstMembers = Me.Controls.Add("VB.ListBox", "lstMembers")
    Set txtValue = Me.Controls.Add("VB.TextBox", "txtValue")
    
    With lstControls
        Call .Move(120, 355, 2000, 3000)
        .Visible = True
    End With
    
    With lstMembers
        Call .Move(2220, 355, 2000, 3000)
        .Visible = True
    End With
    
    With txtValue
        Call .Move(4340, 355, 2000, 355)
        .Visible = True
    End With
    
    With Me.Controls.Add("VB.Label", "lblControls")
        Call .Move(120, 120)
        .AutoSize = True
        .Caption = "Steuerelemente:"
        .Visible = True
    End With
    
    With Me.Controls.Add("VB.Label", "lblMembers")
        Call .Move(2220, 120)
        .AutoSize = True
        .Caption = "Eigenschaften:"
        .Visible = True
    End With
    
    With Me.Controls.Add("VB.Label", "lblValue")
        Call .Move(4340, 120)
        .AutoSize = True
        .Caption = "Wert:"
        .Visible = True
    End With
    
    'meine Gre anpassen
    Call Me.Move(Me.Left, _
                 Me.Top, _
                 txtValue.Left + txtValue.Width + 120, _
                 lstControls.Top + lstControls.Height + 520 _
                 )
    
    'Steuerelemente-Liste auffllen
    For Each ctlControl In Me.Controls
        Call lstControls.AddItem(ctlControl.Name)
    Next ctlControl
End Sub

Private Sub lstControls_Click()
    Call GetMembers(Me.Controls(lstControls.Text))
End Sub

Private Sub GetMembers(objObject As Object)
    'typeninfo. hier kann jede beliebige Typenbibliothek geladen werden
    Dim objTLI As TypeLibInfo
    
    'InterfaceInfo gibt alles zurck,
    'was man ber eine Klasse wissen muss
    Dim objInterFace As InterfaceInfo
    
    'die Members sind die Mitglieder der Klasse
    Dim objMember As MemberInfo
    
    Dim i As Integer
    Dim strTypeName As String, strLastAdded As String
    
    Set objTLI = New TypeLibInfo
    
    'in objTLI.ContainingFile sollte der korrekte Pfad
    'zur vb6.olb eingetragen werden.
    'in der vb6-ide bentigt man keine Pfadangabe.
    'und nicht vergessen: wenn das Programm auf nem andren Rechner
    'laufen soll, wre es ratsam die vb6.olb gleich mitzuliefern!
    objTLI.ContainingFile = "VB6.OLB"
    Call lstMembers.Clear
    
    'Typennamen derer Objekte ermitteln, deren namen sich nicht
    'per TypeName() ermitteln lsst
    If (TypeOf objObject Is MDIForm) Then
        strTypeName = "MDIForm"
    ElseIf (TypeOf objObject Is Form) Then
        strTypeName = "Form"
    Else
        strTypeName = TypeName(objObject)
    End If
    
    'Interface mit dem richtigen Typennamen suchen
    For i = 1 To objTLI.TypeInfos.Count
        If (objTLI.TypeInfos(i).Name = strTypeName) Then
            Set objInterFace = objTLI.TypeInfos(i).Interfaces(1)
            Exit For
        End If
    Next i
    
    If Not (objInterFace Is Nothing) Then
        'smtliche Members (sofern sie Eigenschaften sind,
        'prozeduren werden nicht richtig zurckgegeben) der
        'Eigenschaftenliste hinzfgen. Dabei darauf achten,
        'dass es keine doppelten Eintrge gibt.
        For Each objMember In objInterFace.Members
            If Not (Left$(objMember.Name, 1) = "_") And _
               Not (objMember.Name = strLastAdded) And _
                (objMember.InvokeKind = INVOKE_PROPERTYGET Or _
                 objMember.InvokeKind = INVOKE_PROPERTYPUT Or _
                 objMember.InvokeKind = INVOKE_PROPERTYPUTREF) Then
               
                Call lstMembers.AddItem(objMember.Name)
                strLastAdded = objMember.Name
            End If
        Next objMember
    End If

End Sub

Private Sub lstMembers_Click()
    On Local Error GoTo err_Handler
    
    'Wert ermitteln.
    txtValue.Text = CallByName(Me.Controls(lstControls.Text), _
                               lstMembers.Text, _
                               VbGet)
    
    Exit Sub
err_Handler:
    txtValue.Text = "(fehler)"
    Resume Next
End Sub

